java - 파일 - 메이븐 프로젝트 export




Maven을 사용하여 실행 파일 jar를 빌드 하시겠습니까? (3)

나는 다음과 같이 maven을 사용하여 "logmanager"라는 작은 홈 프로젝트 용 실행 가능한 jar 파일을 생성하려고합니다.

Maven을 사용하여 의존성을 가진 실행 가능한 JAR을 어떻게 만들 수 있습니까?

거기에 표시된 스 니펫을 pom.xml에 추가하고 mvn assembly : assembly를 실행했습니다. logmanager / target : logmanager-0.1.0.jar 및 logmanager-0.1.0-jar-dependencies.jar의 두 개의 jar 파일을 생성합니다. 첫 번째 병을 두 번 클릭하면 오류가 발생합니다.

Could not find the main class: com.gorkwobble.logmanager.LogManager. Program will exit.

jar-with-dependencies.jar를 두 번 클릭하면 약간 다른 오류가 발생합니다.

Failed to load Main-Class manifest attribute from: C:\EclipseProjects\logmanager\target\logmanager-0.1.0-jar-with-dependencies.jar

경로와 클래스 이름을 복사하여 붙여 넣은 다음 POM의 맞춤법을 검사했습니다. 내 메인 클래스는 Eclipse 실행 구성에서 시작됩니다. 누군가 내 jar 파일이 실행되지 않는 이유를 알아낼 수 있습니까? 또한, 왜 두 개의 항아리가 있어야합니까? 더 많은 정보가 필요하면 알려주세요.

다음은 참조 용 전체 pom.xml 입니다.

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>com.gorkwobble</groupId>
  <artifactId>logmanager</artifactId>
  <name>LogManager</name>
  <version>0.1.0</version>
  <description>Systematically renames specified log files on a scheduled basis. Designed to help manage MUSHClient logging and prevent long, continuous log files.</description>
  <build>
    <plugins>
        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-jar-plugin</artifactId>
            <version>2.2</version>
            <!-- nothing here -->
        </plugin>
        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-assembly-plugin</artifactId>
            <version>2.2-beta-4</version>
            <configuration>
              <descriptorRefs>
                <descriptorRef>jar-with-dependencies</descriptorRef>
              </descriptorRefs>
              <archive>
                <manifest>
                  <mainClass>com.gorkwobble.logmanager.LogManager</mainClass>
                </manifest>
              </archive>
            </configuration>
            <executions>
              <execution>
                <phase>package</phase>
                <goals>
                  <goal>single</goal>
                </goals>
              </execution>
            </executions>
          </plugin>
          <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-compiler-plugin</artifactId>
            <configuration>
              <source>1.6</source>
              <target>1.6</target>
            </configuration>
          </plugin>
    </plugins>
  </build>
  <dependencies>
    <!-- commons-lang -->
    <dependency>
        <groupId>commons-lang</groupId>
        <artifactId>commons-lang</artifactId>
        <version>2.4</version>
    </dependency> 

    <!-- Quartz scheduler -->
    <dependency>
        <groupId>opensymphony</groupId>
        <artifactId>quartz</artifactId>
        <version>1.6.3</version>
    </dependency>
    <!-- Quartz 1.6.0 depends on commons collections -->
    <dependency>
      <groupId>commons-collections</groupId>
      <artifactId>commons-collections</artifactId>
      <version>3.1</version>
    </dependency>
    <!-- Quartz 1.6.0 depends on commons logging -->
    <dependency>
      <groupId>commons-logging</groupId>
      <artifactId>commons-logging</artifactId>
      <version>1.1</version>
    </dependency>
    <!-- Quartz 1.6.0 requires JTA in non J2EE environments -->
    <dependency>
      <groupId>javax.transaction</groupId>
      <artifactId>jta</artifactId>
      <version>1.1</version>
      <scope>runtime</scope>
    </dependency>

    <!-- junitx test assertions -->
    <dependency>
        <groupId>junit-addons</groupId>
        <artifactId>junit-addons</artifactId>
        <version>1.4</version>
        <scope>test</scope>
    </dependency>

    <!-- junit dependency; FIXME: make this a separate POM -->
    <dependency>
      <groupId>junit</groupId>
      <artifactId>junit</artifactId>
      <version>4.1</version>
    </dependency>

  </dependencies>
  <dependencyManagement>
  </dependencyManagement>
</project>

https://code.i-harness.com


사실, 당신이 언급 한 질문 에서 주어진 답은 잘못되었습니다 ( UPDATE - 20101106 : 누군가가 고칠 수 있습니다. 대답은 편집을 앞선 버전을 말합니다). 그리고 이것은 적어도 부분적으로 당신이 문제를 일으키는 이유를 설명합니다.

logmanager / target : logmanager-0.1.0.jar 및 logmanager-0.1.0-jar-dependencies.jar의 두 개의 jar 파일을 생성합니다.

첫 번째는 package 단계에서 jar:jar 의해 생성 된 logmanager 모듈의 JAR입니다 (모듈에 jar:jar 유형의 패키지가 있기 때문에). 두 번째는 assembly:assembly 의해 생성 된 assembly:assembly 이며 현재 모듈의 클래스와 그 의존성을 포함해야합니다 (개발자가 jar-with-dependencies 를 사용한 경우).

첫 번째 병을 두 번 클릭하면 오류가 발생합니다.

Could not find the main class: com.gorkwobble.logmanager.LogManager. Program will exit.

참조로 게시 된 제안 된 링크 구성을 적용한 경우 jar 플러그인을 구성하여 다음과 같이 실행 가능 이슈를 생성합니다.

  <plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-jar-plugin</artifactId>
    <configuration>
      <archive>
        <manifest>
          <addClasspath>true</addClasspath>
          <mainClass>com.gorkwobble.logmanager.LogManager</mainClass>
        </manifest>
      </archive>
    </configuration>
  </plugin>

따라서 logmanager-0.1.0.jar 은 실제로 실행 가능하지만 1. 이것은 (모든 종속성이 없기 때문에) 원하는 것이 아니며 2. com.gorkwobble.logmanager.LogManager 가 포함되어 있지 않습니다 (이것은 무엇입니까? 오류가 발생하면 병의 내용을 확인하십시오).

jar-with-dependencies.jar를 두 번 클릭하면 약간 다른 오류가 발생합니다.

Failed to load Main-Class manifest attribute from: C:\EclipseProjects\logmanager\target\logmanager-0.1.0-jar-with-dependencies.jar

다시 말하지만 어셈블리 플러그인을 제안대로 구성한 경우 다음과 같은 결과가 나타납니다.

  <plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-assembly-plugin</artifactId>
    <configuration>
      <descriptorRefs>
        <descriptorRef>jar-with-dependencies</descriptorRef>
      </descriptorRefs>
    </configuration>
  </plugin>

이 설정을 사용하면 logmanager-0.1.0-jar-with-dependencies.jar 에 현재 모듈 해당 종속성의 클래스가 포함되지만 오류에 따라 META-INF/MANIFEST.MF 에는 Main-Class 포함 되지 않습니다 항목 (logmanager-0.1.0.jar에서와 같은 MANIFEST.MF가 아닐 가능성이 큼). jar 파일은 실제로 실행 파일이 아닙니다. 다시 jar 파일은 원하는 내용이 아닙니다.

그래서 필자의 제안은 maven-jar-plugin에서 configuration 요소를 제거하고 다음과 같이 maven-assembly-plugin을 구성하는 것입니다.

  <plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-jar-plugin</artifactId>
    <version>2.2</version>
    <!-- nothing here -->
  </plugin>
  <plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-assembly-plugin</artifactId>
    <version>2.2-beta-4</version>
    <configuration>
      <descriptorRefs>
        <descriptorRef>jar-with-dependencies</descriptorRef>
      </descriptorRefs>
      <archive>
        <manifest>
          <mainClass>org.sample.App</mainClass>
        </manifest>
      </archive>
    </configuration>
    <executions>
      <execution>
        <phase>package</phase>
        <goals>
          <goal>single</goal>
        </goals>
      </execution>
    </executions>
  </plugin>

물론 org.sample.App 를 실행하고자하는 클래스로 대체하십시오. 약간의 보너스, assembly:single 바인딩했습니다 assembly:single package 단계까지 assembly:single 이므로 assembly:assembly 를 실행할 필요가 없습니다. 더 이상 assembly:assembly 를 사용하지 마십시오. 그냥 mvn install 실행하면 표준 빌드 중에 어셈블리가 생성됩니다.

그러므로, 위의 설정으로 pom.xml을 업데이트하고 mvn clean install 실행하십시오. 그런 다음 target 디렉토리로 cd 한 다음 다시 시도하십시오.

java -jar logmanager-0.1.0-jar-with-dependencies.jar

오류가 발생하면 질문을 업데이트하고 META-INF/MANIFEST.MF 파일의 내용과 pom.xml 의 관련 부분 (플러그인 구성 부분)을 게시하십시오. 또한 결과를 게시하십시오 :

java -cp logmanager-0.1.0-jar-with-dependencies.jar com.gorkwobble.logmanager.LogManager

그것은 일식이 무엇인지에 관계없이 명령 행에서 잘 작동 함을 보여줍니다.

편집 : 자바 6 들어, 당신은 maven - 컴파일러 - 플러그인을 구성해야합니다. 이것을 pom.xml에 추가하십시오 :

  <plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-compiler-plugin</artifactId>
    <configuration>
      <source>1.6</source>
      <target>1.6</target>
    </configuration>
  </plugin>

패키지에 어셈블리 목표를 실행하지 않으려면 다음 명령을 사용할 수 있습니다.

mvn package assembly:single

여기 패키지 는 키워드입니다.


Pascal Thivent 의 대답은 나를 도왔습니다. 그러나 <pluginManagement> 요소 내에서 플러그인을 관리하는 경우 플러그인 관리 외부에서 어셈블리를 다시 정의해야합니다. 그렇지 않으면 mvn install 을 실행하면 종속성이 병에 압축되지 않습니다.

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <version>1.0.0-SNAPSHOT</version>
    <packaging>jar</packaging>


    <build>
        <pluginManagement>
            <plugins>

                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-compiler-plugin</artifactId>
                    <version>3.1</version>
                    <configuration>
                        <source>1.6</source>
                        <target>1.6</target>
                    </configuration>
                </plugin>

                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-assembly-plugin</artifactId>
                    <version>2.4</version>
                    <configuration>
                        <archive>
                            <manifest>
                                <mainClass>main.App</mainClass>
                            </manifest>
                        </archive>
                        <descriptorRefs>
                            <descriptorRef>jar-with-dependencies</descriptorRef>
                        </descriptorRefs>
                    </configuration>
                    <executions>
                        <execution>
                            <id>make-assembly</id>
                            <phase>package</phase>
                            <goals>
                                <goal>single</goal>
                            </goals>
                        </execution>
                    </executions>
                </plugin>

            </plugins>

        </pluginManagement>

        <plugins> <!-- did NOT work without this  -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-assembly-plugin</artifactId>
            </plugin>
        </plugins>

    </build>


    <dependencies>
       <!--  dependencies commented out to shorten example -->
    </dependencies>

</project>






executable-jar